// For examples, see:
// https://thegraybook.vvvv.org/reference/extending/writing-nodes.html#examples

namespace Main;

[ProcessNode]
public class SensaCell_0
{
    private int _counter;
}
public int Update(int increment)
{
    //get the input stream
    var inputStream = FStreamIn[i];
    byte[] chunkId1 = new byte[4];
    int chunkSize1 = 0;

    byte[] chunkId2 = new byte[4];
    int chunkSize2 = 0;
    int planeCount = 0;
    int type = 0;
    int dimcount = 0;
    int[] dim = new int[32];
    int[] dimstride = new int[32];
    int datasize = 0;
    double time = 0;

    byte[] data;
    try
    {
        using (var r = new BinaryReader(FStreamIn[i]))
        {
            // First Chunk: int32 id (4 bytes containing chars), int32 size

            chunkId1 = r.ReadBytes(4);
            chunkSize1 = r.ReadInt32();

            chunkId2 = r.ReadBytes(4);
            chunkSize2 = r.ReadInt32(FBo);
            planeCount = r.ReadInt32(FBo);
            type = r.ReadInt32(FBo);
            dimcount = r.ReadInt32(FBo);
            r.Read(dim, 0, 32, FBo);
            r.Read(dimstride, 0, 32, FBo);
            datasize = r.ReadInt32(FBo);
            time = r.ReadDouble(FBo);


            FId[i] = asciiEncoding.GetString(chunkId2);
            FChunkSize[i] = chunkSize2;
            FPlaneCount[i] = planeCount;
            FType[i] = type;
            FDimCount[i] = dimcount;

            FDim.SliceCount = dimcount;
            FDimstride.SliceCount = dimcount;

            for (int j = 0; j < dimcount; j++)
            {
                FDim[j] = dim[j];
            }
            for (int j = 0; j < dimcount; j++)
            {
                FDimstride[j] = dimstride[j];
            }

            FDataSize[i] = datasize;
            FTime[i] = time;

            // process data for output
            data = new byte[datasize];
            data = r.ReadBytes(datasize);

            int pixelCount = dim[0] * dim[1];
            int dataCount = (int)(datasize / planeCount);
            FData.SliceCount = pixelCount * planeCount;
            FDataCol.SliceCount = pixelCount;

            // how many bytes are used to fill up the block?
            int padding = dimstride[1] - dimstride[0] * dim[0];
            int xBlockSize = dim[0] * planeCount + padding;

            // decode to values
            int count = 0;
            for (int j = 0; j < datasize; j++)
            {
                // only consider data that is not padding
                if (j % xBlockSize < dim[0] * planeCount)
                {
                    FData[count] = data[j];
                    count++;
                }
            }

            // decode to color
            if (planeCount <= 4)
            {
                for (int j = 0; j < dataCount; j++)
                {
                    RGBAColor col = new RGBAColor();
                    // cases emulate behaviour in max
                    switch (planeCount)
                    {
                        case 1:
                            col.R = FData[j * planeCount] / 255.0;
                            col.G = FData[j * planeCount] / 255.0;
                            col.B = FData[j * planeCount] / 255.0;
                            col.A = 1;
                            break;
                        case 2:
                            col.G = FData[j * planeCount] / 255.0;
                            col.R = FData[j * planeCount + 1] / 255.0;
                            col.B = FData[j * planeCount + 1] / 255.0;
                            col.A = 1;
                            break;
                        case 3:
                            col.B = FData[j * planeCount] / 255.0;
                            col.R = FData[j * planeCount + 1] / 255.0;
                            col.G = FData[j * planeCount + 2] / 255.0;
                            col.A = 1;
                            break;
                        case 4:
                            col.A = FData[j * planeCount] / 255.0;
                            col.R = FData[j * planeCount + 1] / 255.0;
                            col.G = FData[j * planeCount + 2] / 255.0;
                            col.B = FData[j * planeCount + 3] / 255.0;
                            break;
                        default:
                            break;
                    }
                    FDataCol[j] = col;
                }
            }
        }
    }
    
    catch (Exception)
    { }
    }
    
